package dvdrZ.uTwente.Skilift;

//Resembles the type of a car
public class CarType
{
    private final String name;
    private final int capacity;

    //@ensures Perm(name,100) ** Perm(capacity,100);
    public CarType(String name, int capacity)
    {
        this.name = name;
        this.capacity = capacity;
    }

    /*@
      requires Perm(capacity,50);
      ensures Perm(capacity,50);
     @*/
    public int getCapacity()
    {
        return capacity;
    }

    /*@
      requires Perm(name,50);
      ensures Perm(name,50);
     @*/
    public String getName()
    {

        return name;
    }

    /*@
      requires Perm(name,50);
      ensures Perm(name,50);
     @*/
    @Override
    public int hashCode()
    {

        return name.hashCode();

    }

    /*@
      requires Perm(name,50);
      ensures Perm(name,50);
     @*/
    @Override
    public boolean equals(Object o)
    {
        boolean retval = false;
        if (o instanceof CarType)
        {
            retval = ((CarType) o).name.equals(name);
        }
        return retval;
    }

}